var Ymax; //Variabile globale per aggiornare la scala max del grafico
$(document).ready(function () {
	resizeGraph();
	toastr.success('Wellcome', 'Elmi elettromeccanica');
	var statusImg = ['greyLamp.png', 'greenLamp.png'];
	var alarmImg = [];
	alarmImg.push('greenLamp.png');
	alarmImg.push('redLamp.png');
	var i = 0;
	document.getElementById("log-download").innerHTML = '<a href = "/FileBrowser/Download?Path=%2FDataLogs%2FLetture.csv " target="blank"> download data log';

	// gauge definition-------------------------------------------------------------
	var g1 = new JustGage({
		id: "g_power",
		gaugeWidthScale: 0.8,
		shadowOpacity: 0.5,
		relativeGaugeSize: true,
		noGradient: false,
		titleFontColor: "#fff",
		valueFontColor: "#fff",
		labelFontColor: "#fff",
		labelMinFontSize: 8,
		customSectors: [{ color: 'red', lo: 0, hi: 80 }, { color: 'red', lo: 80, hi: 100.0 }, { color: 'orange', lo: -100, hi: -0.1 }],
		pointer: true,
		value: 0,
		decimals: 1,
		min: -20,
		max: 80,
		title: "Power",
		label: "kW"
	});

	var g2 = new JustGage({
		id: "g_wind_speed",
		gaugeWidthScale: 0.8,
		shadowOpacity: 0.5,
		relativeGaugeSize: true,
		noGradient: false,
		titleFontColor: "#fff",
		valueFontColor: "#fff",
		labelFontColor: "#fff",
		labelMinFontSize: 8,
		//levelColors:["#6666ff","#888888","#ff8888"],
		pointer: true,
		customSectors: [{ color: 'cyan', lo: 0.0, hi: 12.0 }, { color: '#ffff00', lo: 12.1, hi: 18.0 }, { color: '#ff0000', lo: 18.1, hi: 25.0 }],
		counter: true,
		value: 3,
		decimals: 1,
		min: 0,
		max: 25,
		title: "Wind",
		label: "m/s"
	});

	var g3 = new JustGage({
		id: "g_wind_align",
		gaugeWidthScale: 0.44,
		shadowOpacity: 0.5,
		relativeGaugeSize: true,
		noGradient: false,
		titleFontColor: "#fff",
		valueFontColor: "#fff",
		labelFontColor: "#fff",
		labelMinFontSize: 8,
		gaugeColor: "#f0f0f0",
		//		  levelColors:["#6666ff","#888888","#ff8888"],
		pointerOptions: { toplength: -15, bottomlength: 10, bottomwidth: 8, color: '#8e8e93', stroke: '#ffffff', stroke_width: 1, stroke_linecap: 'round' },
		customSectors: [{ color: '#fff', lo: -30, hi: 30 }, { color: 'yellow', lo: -180, hi: -30 }, { color: 'yellow', lo: 30, hi: 180 }],
		pointer: true,
		value: 0,
		symbol: '°',
		min: -90,
		max: 90,
		title: "Wind Alignment Error",
		label: "deg"
	});
	var g4 = new JustGage({
		id: "g_rot-rpm",
		gaugeWidthScale: 0.8,
		shadowOpacity: 0.5,
		relativeGaugeSize: true,
		noGradient: false,
		titleFontColor: "#fff",
		valueFontColor: "#fff",
		labelFontColor: "#fff",
		labelMinFontSize: 8,
		gaugeColor: "#f0f0f0",
		//		  levelColors:["#6666ff","#888888","#ff8888"],
		//          pointerOptions:{toplength: -15,bottomlength: 10,bottomwidth: 8,color: '#8e8e93',stroke: '#ffffff',stroke_width: 1,stroke_linecap: 'round'},
		customSectors: [{ color: 'lightgreen', lo: 0, hi: 50 }, { color: 'red', lo: 50, hi: 100 }],
		pointer: true,
		value: 17.3,
		decimals: 1,
		min: 0,
		max: 60,
		title: "Rotor",
		label: "rpm"
	});
	// End Gauge definition--------------------------------

	//Graph definition------------------------------------- 
	var line_power = new TimeSeries();
	var line_wind = new TimeSeries();
	var line_pitch = new TimeSeries();
	var line_Rrpm = new TimeSeries();

	var graph0 = new SmoothieChart(
		{
			tooltip: false,
			timeStamps: true,
			timestampFormatter: SmoothieChart.timeFormatter,
			yRangeFunction: myYRangeFunction,
			millisPerPixel: 100,
			maxStorageTime: 18000,
			interpolation: "bezier",
			labels: ({ fillStyle: '#fff', fontsize: 8, precision: 1, fontFamily: 'arial' }),
			grid: ({ sharpLines: true, strokeStyle: "gray", fillStyle: "#000", lineWidth: 1, millisPerLine: 10000, verticalSections: 10 })
		});



	graph0.addTimeSeries(line_power, ({ strokeStyle: "red", lineWidth: 2, fillStyle: 'rgba(255, 0, 0, 0.2)' }));
//	graph0.addTimeSeries(line_pitch, ({ strokeStyle: "gray", lineWidth: 2, fillStyle: 'rgba(180, 180, 180, 0.2)' }));
//	graph0.addTimeSeries(line_Rrpm, ({ strokeStyle: "green", lineWidth: 2 }));

	graph0.streamTo(document.getElementById("smoothie"), 1000);

	var graph1 = new SmoothieChart(
		{
			tooltip: false,
			timeStamps: true,
			timestampFormatter: SmoothieChart.timeFormatter,
			minValue: 0,
			maxValue: 25,
			millisPerPixel: 100,
			maxStorageTime: 18000,
			interpolation: "bezier",
			labels: ({ fillStyle: '#fff', fontsize: 8, precision: 1, fontFamily: 'arial' }),
			grid: ({ sharpLines: true, strokeStyle: "gray", fillStyle: "#000", lineWidth: 1, millisPerLine: 10000, verticalSections: 5 })
		});

	graph1.addTimeSeries(line_wind, ({ strokeStyle: "cyan", lineWidth: 2, fillStyle: 'rgba(51,224,255, 0.2)' }));
	graph1.streamTo(document.getElementById("smoothie-wind"), 1000);

	// End Graph definition--------------------------

	// Animate Gauges and Graph---------------------
	$.ajaxSetup({ cache: false });
	setInterval(function () {
		$.get("Variables/getVar.html", function (result) {
			//	result = '{"emerg":0, "auto":0,"alarm":0 }';
			result = JSON.parse(result);
			line_power.append(new Date().getTime(), result['power']);
			g1.refresh(result['power'],Ymax);
			line_wind.append(new Date().getTime(), result['windSpeed']);
			g2.refresh(result['windSpeed']);
			line_pitch.append(new Date().getTime(), result['pitchAngle']);
			line_Rrpm.append(new Date().getTime(), result['rotorRpm']);
			$('#rotorRpm').text(result['rotorRpm']);
			g4.refresh(result['rotorRpm']);
			$('#genRpm').text(result['genRpm']);
			g3.refresh(parseInt(result['windAlign']));
			$('#EA_EX_Tot').text(result['EA_EX_Tot']);
			$('#EA_EX_Today').text(result['EA_EX_Today']);
			$('#avg-power').text(result['powerAvg']);
			//Emergenza
			var f = document.getElementById('emerg-txt');
			var element = document.getElementById("emerg-led");
			if (result['emerg'] == 1) {
				element.className = element.className.replace("led-yellow-blink", "led-yellow-on");
				$('#emerg-txt').text("Catena emergenza chiusa");
				f.style.color = 'white';
			}
			else {
				element.className = element.className.replace("led-yellow-on", "led-yellow-blink");
				$('#emerg-txt').text("Catena emergenza aperta");
				f.style.color = (f.style.color == 'yellow' ? '#777' : 'yellow');
			}
			//Automatico
			f = document.getElementById('auto-txt');
			element = document.getElementById("auto-led");
			if (result['auto'] == 1) {
				element.className = element.className.replace("led-green-off", "led-green-on");
				$('#auto-txt').text("Automatico ON");
				f.style.color = 'white';
			}
			else {
				element.className = element.className.replace("led-green-on", "led-green-off");
				$('#auto-txt').text("Automatico OFF");
				f.style.color = (f.style.color == 'white' ? '#777' : 'white');
			}
			//Allarme
			f = document.getElementById('alarm-txt');
			element = document.getElementById("alarm-led");
			if (result['alarm'] == 0) {
				element.className = element.className.replace("led-red-blink", "led-red-off");
				$('#alarm-txt').text("Nessun Allarme");
				f.style.color = 'white';
			}
			else {
				element.className = element.className.replace("led-red-off", "led-red-blink");
				$('#alarm-txt').text("Allarme in Corso");
				f.style.color = (f.style.color == 'red' ? '#777' : 'red');
			}
			//Wind cut-in cut-out
			f = document.getElementById('wind-txt');
			element = document.getElementById("wind-led");
			if (result['windStatus'] == 0) {
				element.className = element.className.replace("led-green-on", "led-green-off");
				element.className = element.className.replace("led-red-blink", "led-green-off");
				$('#wind-txt').text(" In attesa");
				f.style.color = 'white';
			}
			else if (result['windStatus'] == 1) {
				element.className = element.className.replace("led-green-off", "led-green-on");
				element.className = element.className.replace("led-red-blink", "led-green-on");
				$('#wind-txt').text(" OK");
				f.style.color = 'white';
			}
			else if (result['windStatus'] == 2) {
				element.className = element.className.replace("led-green-off", "led-red-blink");
				element.className = element.className.replace("led-green-on", "led-red-blink");
				$('#wind-txt').text(" CUT_OUT!");
				f.style.color = (f.style.color == 'red' ? '#777' : 'red');
			}

			//Taglio potenza
			f = document.getElementById('powercut-txt');
			element = document.getElementById("powercut-led");
			if (result['powerCutActive'] == 0) {
				element.className = element.className.replace("led-red-blink", "led-red-off");
				$('#powercut-txt').text(" Non Attivo");
				f.style.color = 'white';
			}
			else {
				element.className = element.className.replace("led-red-off", "led-red-blink");
				$('#powercut-txt').text(" Attivo!");
				f.style.color = (f.style.color == 'red' ? '#777' : 'red');
			}



			//Box messaggi
			toastr.options.timeOut = 5000;
			toastr.options.extendedTimeOut = 0;
			if (result['IOtoastrvalue'] != 'NONE') {
				toastr.error(result['IOtoastrvalue'].trim(), 'W A R N I N G !');
			}
		});
	}, 1000);
});
// End Animate

//-------------------------------------
// Aggiorna la scala max Y del grafico
function myYRangeFunction() {
	var min = 0;
	var max = getYmax();
	return { min: min, max: max };
}
function getYmax() {
	$.get("Variables/graphStyle.html", function (result) {
		Ymax = parseInt(result);
		if (isNaN(Ymax)) {
			Ymax = 100;
		}
	});
	return Ymax;
}
//-----------------------------------


function resizeGraph() {
	var newWidth = $('#main').innerWidth();
	var graphCanvas1 = document.getElementById("smoothie");
	graphCanvas1.width = newWidth;
	var graphCanvas2 = document.getElementById("smoothie-wind");
	graphCanvas2.width = newWidth;
}

